SORT(1)

NAME
sort - sort, merge or check the sortedness of text files

SYNOPSIS
sort [-bdfHilnrSsu] [ -k kstart[,kend] ...] [-o output] [-R char] [-T dir] [-t char] [file ...]
sort -m [-bdfHilnrSsu] [ -k kstart[,kend] ...] [-o output] [-R char] [-T dir] [-t char] [file ...]
sort -C|-c [-bdfilnru] [ -k kstart[,kend] ...] [-R char] [-t char] [file]

DESCRIPTION
The sort utility performs one of three operations on its input files:

1.  If none of the options -C, -c or -m are specified, the sort utility will sort the lines of the specified input files together and write the result to the specified output.

2.  If the -m option is specified, the sort utility will merge the lines of the specified input files and write the result to the specified output. The input files are expected to be presorted for this mode of operation.

3.  If either of the -C or -c options are specified, the sort utility will indicate by its exit status whether a single input file is correctly sorted.

Comparisons are based on one or more sort keys extracted from each line of input, and are performed lexicographically. By default, if keys are not given, sort regards each input line as a single field.

The following options are available:

-C  Identical to -c without the error messages in the case of unsorted input.

-c  Check that the single input file is sorted. If the file is not sorted, sort produces the appropriate error messages and exits with code 1; otherwise, sort returns 0. sort -c produces no output. See also -u.

-H  Ignored for compatibility with earlier versions of sort.

-m  Merge only; the input files are assumed to be pre-sorted.

-o output
    The argument given is the name of an output file to be used instead of the standard output. This file can be the same as one of the input files.

-S  Don't use stable sort. Default is to use stable sort.

-s  Use stable sort, keeps records with equal keys in their original order. This is the default. Provided for compatibility with other sort implementations only.

-T dir
    Use dir as the directory for temporary files. The default is the value specified in the environment variable TMPDIR or /tmp if TMPDIR is not defined.

-u  Unique: suppress all but one in each set of lines having equal keys. If used with the -c option, check that there are no lines with duplicate keys.

The following options, which should be given before any -k options, override the default ordering rules. When ordering options appear independent of, and before, key field specifications, the requested field ordering rules are applied globally to all sort keys. When attached to a specific key (see -k), the ordering options override all global ordering options for that key.

-d  Only blank space and alphanumeric characters are used in making comparisons.

-f  Considers all lowercase characters that have uppercase equivalents to be the same for purposes of comparison.

-i  Ignore all non-printable characters.

-l  Sort by the string length of the field, not by the field itself.

-n  An initial numeric string, consisting of optional blank space, optional plus or minus sign, and zero or more digits (including decimal point) is sorted by arithmetic value. ( The -n option no longer implies the -b option).

-r  Reverse the sense of comparisons.

The treatment of field separators can be altered using these options:

-b  Ignores leading blank space when determining the start and end of a restricted sort key. A -b option specified before the first -k option applies globally to all -k options. Otherwise, the -b option can be attached independently to each field argument of the -k option (see below). Note that the -b option has no effect unless key fields are specified.

-k kstart[,kend]
    Designates the starting position, kstart, and optional ending position, kend, of a key field. The -k option replaces the obsolescent options +pos1 and -pos2.

-R char
    char is used as the record separator character. This should be used with discretion; -R <alphanumeric> usually produces undesirable results. If char is not a single character, then it specifies the value of the desired record separator as an integer specified in any of the normal ddd, 0ooo, or 0xhh ways, or as an octal value preceded by a backslash (‘\’). Caution: do not attempt to specify ‘\^A’ (SOH) as ‘-R 1’ which will not do what was intended at all! The default record separator is newline.

-t char
    char is used as the field separator character. The initial char is not considered to be part of a field when determining key offsets (see below). Each occurrence of char is significant ( for example, ‘<char><char>’ delimits an empty field). If -t is not specified, the default field separator is a sequence of blank-space characters, and consecutive blank spaces do not delimit an empty field; further, the initial blank space is considered part of a field when determining key offsets.

The following operands are available:

file
    The pathname of a file to be sorted, merged, or checked. If no file operands are specified, or if a file operand is -, the standard input is used.

A field is defined as a minimal sequence of characters followed by a field separator or a newline character. By default, the first blank space of a sequence of blank spaces acts as the field separator. All blank spaces in a sequence of blank spaces are considered as part of the next field; for example, all blank spaces at the beginning of a line are considered to be part of the first field.

Fields are specified by the -k kstart[,kend] argument. A missing kend argument defaults to the end of a line.

The arguments kstart and kend have the form m[.n] (m, n > 0) and can be followed by one or more of the letters b, d, f, i, l, n, and r, which correspond to the options discussed above.

A kstart position specified by m.n is interpreted as the n'th character in the m'th field. A missing.n in kstart means ‘.1’, indicating the first character of the m'th field; if the -b option is in effect, n is counted from the first non-blank character in the m'th field; m.1b refers to the first non-blank character in the m'th field.

A kend position specified by m.n is interpreted as the n'th character (including separators) of the m'th field. A missing.n indicates the last character of the m'th field; m = 0 designates the end of a line.

Thus the option -k v.x,w.y is synonymous with the obsolescent options +v-1.x-1 -w-1.y. When y is omitted, -k v.x,w is synonymous with +v-1.x-1 -w+1.0. The obsolescent +pos1 -pos2 options are still supported, except for - w.0b, which has no -k equivalent.

sort compares records by comparing the key fields selected by -k arguments, from first given to last, until discovering a difference. If there are no -k arguments, the whole record is treated as a single key. After exhausting the -k arguments, if no difference has been found, then the result depends upon the -u and -S option settings. With -u the records are considered identical, and one is suppressed. Otherwise with -s set (default) the records are left in their original order, or with -S (POSIX mode) the whole record is considered as a tie breaker.

ENVIRONMENT
If the following environment variable exists, it is used by sort.

TMPDIR
    sort uses the contents of the TMPDIR environment variable as the path in which to store temporary files.

FILES
/tmp/sort.*
    Default temporary files.
output<NUMBER>
    Temporary file which is used for output if output already exists. Once sorting is finished, this file replaces output ( via link(2) and unlink(2)).

EXAMPLES
To silently check if the lines in a file are sorted lexicographically, use:

    $ sort -C file

To merge three pre-sorted files and write the merged result to stdout, use:

    $ sort -m file1 file2 file3

To sort lines lexicographically using the second whitespace-separated field of each line as the sort key preserving leading whitespace in the sort key, use:

    $ sort -k 2 <<EOF
      aa bb
      ab   bb
    EOF
      ab   bb
      aa bb
    $

To sort lines lexicographically using the second whitespace-separated field on each line as the sort key ignoring any leading whitespace in the sort key, use:

    $ sort -k 2b <<EOF
      aa bb
      ab   bb
    EOF
      aa bb
      ab   bb
    $

To sort lines numerically, using the second whitespace-separated field on each line as the sort key, starting the sort key at the second non-blank character within the field, use:

    $ sort -k 2.2nb <<EOF
      aa  X42
      ab Y24
    EOF
      ab Y24
      aa  X42
    $

To sort lines numerically with a sort key starting on the second character of the second whitespace delimited field and to further sort lines with equal keys lexicographically on the first whitespace delimited field, use:

    $ sort -k 2.2n -k 1 <<EOF
      ab X42
      aa Y42
      ac Z43
    EOF
      aa Y42
      ab X42
      ac Z43

To lexicographically sort the lines of a file in reverse order, use:

    $ sort -r -f file

EXIT STATUS
Sort exits with one of the following values:
0   Normal behavior.
1   On disorder (or non-uniqueness) with the -c (or -C) option.
2   An error occurred.

SEE ALSO
comm(1), join(1), uniq(1), qsort(3), radixsort(3)

HISTORY
A sort command appeared in AT&T UNIX. This sort implementation appeared in 4.4BSD and is used since NetBSD 1.6.

BUGS
POSIX requires the locale's thousands separator be ignored in numbers.

It may be faster to sort very large files in pieces and then explicitly merge them.

NOTES
This sort has no limits on input line length (other than imposed by available memory) or any restrictions on bytes allowed within lines.

To protect data sort -o calls link(2) and unlink(2), and thus fails on protected directories.

Input files should be text files. If file doesn't end with record separator (which is typically newline), the sort utility silently supplies one.

The current sort uses lexicographic radix sorting, which requires that sort keys be kept in memory ( as opposed to previous versions which used quick and merge sorts and did not). Thus performance depends highly on efficient choice of sort keys, and the -b option and the kend argument of the -k option should be used whenever possible. Similarly, sort -k1f is equivalent to sort -f and may take twice as long.